# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetZPAApplicationServerResult',
    'AwaitableGetZPAApplicationServerResult',
    'get_zpa_application_server',
    'get_zpa_application_server_output',
]

@pulumi.output_type
class GetZPAApplicationServerResult:
    """
    A collection of values returned by getZPAApplicationServer.
    """
    def __init__(__self__, address=None, app_server_group_ids=None, config_space=None, creation_time=None, description=None, enabled=None, id=None, modified_time=None, modifiedby=None, name=None):
        if address and not isinstance(address, str):
            raise TypeError("Expected argument 'address' to be a str")
        pulumi.set(__self__, "address", address)
        if app_server_group_ids and not isinstance(app_server_group_ids, list):
            raise TypeError("Expected argument 'app_server_group_ids' to be a list")
        pulumi.set(__self__, "app_server_group_ids", app_server_group_ids)
        if config_space and not isinstance(config_space, str):
            raise TypeError("Expected argument 'config_space' to be a str")
        pulumi.set(__self__, "config_space", config_space)
        if creation_time and not isinstance(creation_time, str):
            raise TypeError("Expected argument 'creation_time' to be a str")
        pulumi.set(__self__, "creation_time", creation_time)
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if enabled and not isinstance(enabled, bool):
            raise TypeError("Expected argument 'enabled' to be a bool")
        pulumi.set(__self__, "enabled", enabled)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if modified_time and not isinstance(modified_time, str):
            raise TypeError("Expected argument 'modified_time' to be a str")
        pulumi.set(__self__, "modified_time", modified_time)
        if modifiedby and not isinstance(modifiedby, str):
            raise TypeError("Expected argument 'modifiedby' to be a str")
        pulumi.set(__self__, "modifiedby", modifiedby)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def address(self) -> str:
        """
        (string) This field defines the domain or IP address of the server.
        """
        return pulumi.get(self, "address")

    @property
    @pulumi.getter(name="appServerGroupIds")
    def app_server_group_ids(self) -> Sequence[str]:
        """
        (Set of String) This field defines the list of server groups IDs.
        """
        return pulumi.get(self, "app_server_group_ids")

    @property
    @pulumi.getter(name="configSpace")
    def config_space(self) -> str:
        return pulumi.get(self, "config_space")

    @property
    @pulumi.getter(name="creationTime")
    def creation_time(self) -> str:
        return pulumi.get(self, "creation_time")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        (string) This field defines the description of the server.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def enabled(self) -> bool:
        """
        (bool) This field defines the status of the server.
        """
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter
    def id(self) -> Optional[str]:
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="modifiedTime")
    def modified_time(self) -> str:
        return pulumi.get(self, "modified_time")

    @property
    @pulumi.getter
    def modifiedby(self) -> str:
        return pulumi.get(self, "modifiedby")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        return pulumi.get(self, "name")


class AwaitableGetZPAApplicationServerResult(GetZPAApplicationServerResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetZPAApplicationServerResult(
            address=self.address,
            app_server_group_ids=self.app_server_group_ids,
            config_space=self.config_space,
            creation_time=self.creation_time,
            description=self.description,
            enabled=self.enabled,
            id=self.id,
            modified_time=self.modified_time,
            modifiedby=self.modifiedby,
            name=self.name)


def get_zpa_application_server(id: Optional[str] = None,
                               name: Optional[str] = None,
                               opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetZPAApplicationServerResult:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_zpa as zpa

    example = zpa.get_zpa_application_server(name="server.example.com")
    ```

    ```python
    import pulumi
    import pulumi_zpa as zpa

    example = zpa.get_zpa_application_server(id="1234567890")
    ```


    :param str id: This field defines the id of the application server.
    :param str name: This field defines the name of the server.
    """
    __args__ = dict()
    __args__['id'] = id
    __args__['name'] = name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('zpa:index/getZPAApplicationServer:getZPAApplicationServer', __args__, opts=opts, typ=GetZPAApplicationServerResult).value

    return AwaitableGetZPAApplicationServerResult(
        address=__ret__.address,
        app_server_group_ids=__ret__.app_server_group_ids,
        config_space=__ret__.config_space,
        creation_time=__ret__.creation_time,
        description=__ret__.description,
        enabled=__ret__.enabled,
        id=__ret__.id,
        modified_time=__ret__.modified_time,
        modifiedby=__ret__.modifiedby,
        name=__ret__.name)


@_utilities.lift_output_func(get_zpa_application_server)
def get_zpa_application_server_output(id: Optional[pulumi.Input[Optional[str]]] = None,
                                      name: Optional[pulumi.Input[Optional[str]]] = None,
                                      opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetZPAApplicationServerResult]:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_zpa as zpa

    example = zpa.get_zpa_application_server(name="server.example.com")
    ```

    ```python
    import pulumi
    import pulumi_zpa as zpa

    example = zpa.get_zpa_application_server(id="1234567890")
    ```


    :param str id: This field defines the id of the application server.
    :param str name: This field defines the name of the server.
    """
    ...
